*! version 0.3.1 2014-08-03 | scott long | labels
*! version 0.3.0 2014-08-02 | scott long | tempname
*  version 0.2.1 2014-08-01 | long | scalar

//  matmath: math operations on matrices

capture program drop _matmath

program _matmath, sclass

    version 11.2
    syntax, matout(string) matleft(string) ///
        isunary(string) isbinary(string) isbook(string) ///
        isscalar(string) ///
        [ matright(string) operator(string) ] ///
        [ list cols(string) rows(string) ]

    tempname scalarright matrows matcols

if "$debug"=="1" di "matout `matout'"

    mata: `matleft' = st_matrix(st_local("matleft"))
    local matleftrownms : rownames `matleft'
    local matleftcolnms : colnames `matleft'
    local matleftrowsN = rowsof(`matleft')
    local matleftcolsN = colsof(`matleft')

//  binary operations

    if `isbinary' {

        if `isscalar' {
            matrix `scalarright' = J(1,1,`matright')
            mata: `matright' = st_matrix("`scalarright'")
        }
        else mata: `matright' = st_matrix(st_local("matright"))
        local useleftrownms = 0
        local useleftcolnms = 0

        * math operations
        if "`operator'"=="-" {
            mata: `matout' = `matleft' :- `matright'
            mata: st_matrix(st_local("matout"),`matout')
            local useleftrownms = 1
            local useleftcolnms = 1
        }
        else if "`operator'"=="+" {
            mata: `matout' = `matleft' :+ `matright'
            mata: st_matrix(st_local("matout"),`matout')
            local useleftrownms = 1
            local useleftcolnms = 1
        }
        else if "`operator'"=="*" {
            mata: `matout' = `matleft' :* `matright'
            mata: st_matrix(st_local("matout"),`matout')
            local useleftrownms = 1
            local useleftcolnms = 1
        }
        else if "`operator'"=="/" {
            mata: `matout' = `matleft' :/ `matright'
            mata: st_matrix(st_local("matout"),`matout')
            local useleftrownms = 1
            local useleftcolnms = 1
        }
        else if "`operator'"=="^" {
            mata: `matout' = `matleft' :^ `matright'
            mata: st_matrix(st_local("matout"),`matout')
            local useleftrownms = 1
            local useleftcolnms = 1
        }
        * what percent is first matrix of second matrix
        else if "`operator'"=="%of" {
            mata: `matout' = 100*(`matleft' :/ `matright')
            mata: st_matrix(st_local("matout"),`matout')
            local useleftrownms = 1
            local useleftcolnms = 1
        }
        * percent change from first to second matrix
        else if "`operator'"=="%dif" {
            mata: `matout' = 100*((`matright' :- `matleft' ):/ `matleft')
            mata: st_matrix(st_local("matout"),`matout')
            local useleftrownms = 1
            local useleftcolnms = 1
        }
        * stacking operations
        if `isscalar' & ("`operator'"=="," | "`operator'"==",," | ///
            "`operator'"=="\" | "`operator'"=="\\") {
            di as err "operator `operator' is not allowed with scalars"
            exit
        }

        if "`operator'"=="," {
            matrix `matout' = `matleft' , `matright'
            local useleftrownms = 1
        }
        if "`operator'"=="\" {
            matrix `matout' = `matleft' \ `matright'
            local useleftcolnms = 1
        }
        if "`operator'"==",," {
                mat_capp `matout' : `matleft' `matright', miss(.)
        }
        if "`operator'"=="\\" {
                mat_rapp `matout' : `matleft' `matright', miss(.)
        }

        * attach labels
        if `useleftrownms' matrix rownames `matout' = `matleftrownms'
        if `useleftcolnms' matrix colnames `matout' = `matleftcolnms'

    } // binary

    if `isunary' {

        local useleftrownms = 0
        local useleftcolnms = 0
        if "`operator'"=="sqrt" {
            mata: `matout' = sqrt(`matleft')
            mata: st_matrix(st_local("matout"),`matout')
            local useleftrownms = 1
            local useleftcolnms = 1
        }
        else if "`operator'"=="sq" {
            mata: `matout' = `matleft' :* `matleft'
            mata: st_matrix(st_local("matout"),`matout')
            local useleftrownms = 1
            local useleftcolnms = 1
        }
        else if "`operator'"=="log" {
            mata: `matout' = log(`matleft')
            mata: st_matrix(st_local("matout"),`matout')
            local useleftrownms = 1
            local useleftcolnms = 1
        }
        else if "`operator'"=="log10" {
            mata: `matout' = log10(`matleft')
            mata: st_matrix(st_local("matout"),`matout')
            local useleftrownms = 1
            local useleftcolnms = 1
        }
        else if "`operator'"=="exp" {
            mata: `matout' = exp(`matleft')
            mata: st_matrix(st_local("matout"),`matout')
            local useleftrownms = 1
            local useleftcolnms = 1
        }
        else if "`operator'"=="inv" {
            mata: `matout' = 1 :/ `matleft'
            mata: st_matrix(st_local("matout"),`matout')
            local useleftrownms = 1
            local useleftcolnms = 1
        }
        else if ("`operator'"=="logit") ///
            mata: `matout' = log( `matleft' :/ (1 :- `matleft') )
            mata: st_matrix(st_local("matout"),`matout')
            local useleftrownms = 1
            local useleftcolnms = 1
        else if ("`operator'"=="odds") ///
            mata: `matout' = ( `matleft' :/ (1 :- `matleft') )
            mata: st_matrix(st_local("matout"),`matout')
            local useleftrownms = 1
            local useleftcolnms = 1

        if `useleftrownms' matrix rownames `matout' = `matleftrownms'
        if `useleftcolnms' matrix colnames `matout' = `matleftcolnms'

    } // unary

    if `isbook' {

        * put `matleft' into mata as `matout'
        mata: `matout' = st_matrix(st_local("matleft"))
        local matleftrownms : rowfullnames `matleft'
        local matleftcolnms : colfullnames `matleft'
*matlist `matleft' , title(MATLEFT)

        if "`operator'"=="keep" {

            * row indices
            if ("`rows'"=="") matrix `matrows' = J(1,1,.)
            else {
                foreach r in `rows' {
                    if `r'>`matleftrowsN' | `r'<1 {
                        di as error ///
                            "row `r' in keep() is invalid"
                        local iserror = 1
                    }
                }
                local tmp = subinstr("`rows'"," ","\",.)
                matrix `matrows' = (`tmp')
            }
            mata: `matrows' = st_matrix("`matrows'")
            * column indices
            if ("`cols'"=="") matrix `matcols' = J(1,1,.)
            else {
                foreach c in `cols' {
                    if `c'>`matleftcolsN' | `c'<1 {
                        di as error ///
                            "column `c' in keep() is invalid"
                        local iserror = 1
                    }
                }
                local tmp = subinstr("`cols'"," ","\",.)
                matrix `matcols' = (`tmp')
            }
            mata: `matcols' = st_matrix("`matcols'")

            if ("`iserror'"=="1") exit

            mata: `matout' = `matout'[`matrows',`matcols']
            mata: st_matrix(st_local("matout"),`matout')
        }

        else if "`operator'"=="drop" {

            * matrix with rows to keep
            local tmpindices ""
            forvalues row = 1/`matleftrowsN' {
                local ipos : list posof "`row'" in rows
                if (`ipos'==0) local tmpindices "`tmpindices' \ `row'"
            }
            local tmpindices = subinstr("`tmpindices'"," \ ","",1)
            matrix `matrows' = (`tmpindices')
            * remove \ between indices
            local rows = subinstr("`tmpindices'","\"," ",.) // used later
            mata: `matrows' = st_matrix("`matrows'")

            * with columns
            local tmpindices ""
            forvalues col = 1/`matleftcolsN' {
                local ipos : list posof "`col'" in cols
                if (`ipos'==0) local tmpindices "`tmpindices' , `col'"
            }
            local tmpindices = subinstr("`tmpindices'"," , ","",1)
            matrix `matcols' = (`tmpindices')
            * remove , between indices
            local cols = subinstr("`tmpindices'",","," ",.)
            mata: `matcols' = st_matrix("`matcols'")
            mata: `matout' = `matout'[`matrows',`matcols']
            mata: st_matrix(st_local("matout"),`matout')
        }

        * reattach labels
        foreach row in `rows' {
            local rnm : word `row' of `matleftrownms'
            local newrownms `" `newrownms' `rnm' "'
        }
        matrix rownames `matout' = `newrownms'
        foreach col in `cols' {
            local rnm : word `col' of `matleftcolnms'
            local newcolnms `" `newcolnms' `rnm' "'
        }
        matrix colnames `matout' = `newcolnms'

    } // book

    if ("`list'"=="list") matlist `matout', title(matrix `matout')

end
exit

    if "`eq'" == "" {
        matrix list `matout'
        exit
    }

    if "`matleft'"=="" {
        display as error ///
        "matmath A = B <op> C: matrix B is not specified"
        exit
    }

    if "`eq'"!="=" {
        display as error ///
        "matmath A = B <op> C: equal sign is missing"
        exit
    }

    if "`matright'"=="" {
        display as error ///
        "matmath A = B <op> C: matrix C is not specified"
        exit
    }

    if "`op'"=="" {
        display as error ///
        "matmath A = B <op> C: <op> is not specified"
        exit
    }

    local isapp = inlist("`op'","capp","rapp")
    local isconcat = inlist("`op'",",","\")
    local isrcat = inlist("`op'",",")
    local isccat = inlist("`op'","\")
    local okop = inlist("`op'","+","-","*","/",",","\","%")
    if !`okop' & !`isapp' {
        display as error ///
        "invalid operator: operators can be + - * / % , \ capp rapp"
        exit
    }