*! version 0.3.0 2014-08-02 | scott long | tempname
*  version 0.2.1 2014-08-01 | scott long | scalar

capture program drop matmath
program matmath, sclass

    version 11.2

    local binaryops "+ - / * ^ , ,, \ \\ %of %dif"
    local unaryops "sqrt sq log log10 exp inv power"
    local bookops "keep drop"

    local input "`*'"
    * make cols() a synonym for columns()
    local input : subinstr local input "cols(" "col(", all

//  get options

    * remove , so _decodeoptions can use syntax
    local tempinput : subinstr local input "," " ", all
    _decodeoptions, `tempinput'
    local list "`s(list)'"
    local colis "`s(columns)'"
    local rowis "`s(rows)'"

//  determine operation being requested

    * ,, to ! and \\ to @ to distinguish ,, from ,; \\ from \
    local input : subinstr local input ",," "!", all
    local input : subinstr local input "\\" "@", all

    foreach t in = `binaryops' {
        local input = subinstr("`input'","`t'"," `t' ",.) // space around operators
    }
    local input = subinstr("`input'","  "," ",.)
    local input : subinstr local input "!" " ,, ", all
    local input : subinstr local input "@" " \\ ", all
    local input : subinstr local input " (" "(", all
    local input : subinstr local input "(" "( ", all
    local input : subinstr local input ")" " )", all

    * isbook
    local isbook = 0
    foreach t in `bookops' {
        local ipos : list posof "`t'(" in input
        if `ipos'>0 {
            local isbook = 1
            local is`t' = 1
            local operator "`t'"
        }
    }

    * isunary
    local isunary = 0
    foreach t in `unaryops' {
        local ipos : list posof "`t'(" in input
        if `ipos'>0 {
            local isunary = 1
            local is`t' = 1
            local operator "`t'"
        }
    }

    * isbinary
    local isbinary = 0
    if !`isbook' & !`isunary' {
        local isbinary = 1
    }

//  matrices

    if `isbinary' {
        _decodebinary `input'
        local matout `s(matout)'
        local eq "`s(eq)'"
        local matleft `s(matleft)'
        local matright `s(matright)'
        local operator `s(op)'
        local ipos : list posof "`operator'" in binaryops
        if `ipos'==0 {
            di as error "operator `operator' is invalid"
            exit
        }
    }

    if `isunary' | `isbook' {
        local matout : word 1 of `input'
        local eq : word 2 of `input'
        local matleft : word 4 of `input'
        local matright ""
        local isscalar = 0
    }

    local iserror = 0
    if "`eq'"!="=" {
        di as error "missing = sign"
        local iserror = 1
    }
    capture confirm matrix `matleft'
    if _rc {
        di as error "matrix `matleft' does not exist"
        local iserror = 1
    }

    if `isbinary' {

        tempname tmp
        * is matrix?
        capture confirm matrix `matright'
        if _rc local ismatrix = 0 // not matrix
        else local ismatrix = 1

        * is scalar?
        local isscalar = 0
        if `ismatrix'==0 { // is it a scalar
            capture scalar `tmp' = `matright'
            capture confirm scalar `tmp'
            if _rc local isscalar = 0
            else local isscalar = 1
        }
        if `isscalar'==0 & `ismatrix'==0 {
            local iserror = 1
            di as error ///
            "the right element in `matleft' `operator' `matright' does not exist"
        }
*di "ismatrix = `ismatrix'  isscalar = `isscalar'"
        if !`isscalar' {
            local matleftrowsN = rowsof(`matleft')
            local matleftcolsN = colsof(`matleft')
            local matrightrowsN = rowsof(`matright')
            local matrightcolsN = colsof(`matright')
            if (`matleftrowsN'!=`matrightrowsN' ///
                    | `matleftcolsN'!=`matrightcolsN')  {
                if "`operator'"!=",," & "`operator'"!="\\" {
                    display as error ///
                    "dimensions of matrices are incompatabile"
                    local iserror = 1
                }
            }
        }
    }

/*
di "input is |`input'|"
di "DECODED"
di "isunary = `isunary'     operator!`operator'!"
di "isbook = `isbook'       operator!`operator'!"
di "isbinary = `isbinary'   operator!`operator'!"
di "matout: `matout'    matleft:   `matleft'      matright:   `matright'"
di "list!`list'!        colis !`colis'!     rowis !`rowis'!"
*/
    if `iserror' exit

//  dimensions

    _matmath , matout(`matout') matleft(`matleft') matright(`matright') ///
        isunary(`isunary') isbinary(`isbinary') isbook(`isbook') ///
        isscalar(`isscalar') operator(`operator') ///
        `list' cols(`colis') rows(`rowis')

    local nrows = rowsof(`matout')
    local ncols = colsof(`matout')
    sreturn local nrows `nrows'
    sreturn local ncols `ncols'
end

program _decodeoptions, sclass
    syntax [ ,  Rows(numlist) Columns(numlist) list * ]
    sreturn local rows `rows'
    sreturn local columns `columns'
    sreturn local list `list'
end

program _decodebinary, sclass
    args matout eq matleft op matright opt1 opt2 opt3 opt4
    sreturn local matout `matout'
    sreturn local eq "`eq'"
    sreturn local matleft `matleft'
    sreturn local op "`op'"
    sreturn local matright `matright'
end

exit
