{smcl}
{* 2014-08-03}{...}
{title:Title}
{p2colset 5 16 23 2}{...}

{p2col:{cmd:matmath} {hline 2}}Matrix operations made simple | 2014-08-01{p_end}
{p2colreset}{...}


{title:General syntax}

{p 2 18 2}
{ul:Binary operations on each element}

{p 6 6 2}
{cmd:matmath } {it:Mresult} = {it:Mleft} {it:operator} {it:Mright} [, list]

{p 2 18 2}
{ul:Unary operations on each element}

{p 6 6 2}
{cmd:matmath } {it:Mresult} = [{it:operator}]({it:Mleft}) [, list]

{p 2 18 2}
{ul:Bookkeeping operations on matrix}

{p 6 6 2}
{cmd:matmath } {it:Mresult} = [{it:task}]({it:Mleft}), {opt rows(numlist)}|{opt col:umns(numlist)} [list]

{p 2 18 2}
{ul:Matrices and scalars used}

{p 6 6 2}
{it:Mresult} is the resulting matrix, which can be an existing matrix. An existing matrix will be over-written.

{p 6 6 2}
{it:Mleft} is a matrix to be modified. For unary operators, only {it:Mleft} is required.

{p 6 6 2}
{it:Mright} can be a matrix of the same dimensions as {it:Mleft} or it can be a scalar.

{p 6 6 2}
The row and column names in {it:Mresult} correspond to those in {it:Mleft}.

{marker overview}
{title:Overview}

{pstd}
{cmd:matmath} makes basic matrix operations simple!
{p_end}

{title:Expanded syntax}

{dlgtab:Binary operations}

{p 6 10 2}
{cmd:matmath } {it:Mresult} = {it:Mleft} {it:operator} {it:Mright}

{p2colset 10 22 22 12}{...}
{p2col :Operator}What it does{p_end}
{p2line}
{p2col :{bf:+}}Addition of left and right{p_end}
{p2col :{bf:-}}Subtraction left from right{p_end}
{p2col :{bf:*}}Multiplication left times right{p_end}
{p2col :{bf:/}}Division left by right{p_end}
{p2col :{bf:^}}Exponentiation of left to right power{p_end}
{p2col :{bf:%of}}Left as percent of right{p_end}
{p2col :{bf:%dif}}Change from left to right as percent of left{p_end}
{p2col :{bf:,}}Column concantenate left with right{p_end}
{p2col :{bf:,,}}Column concantenate left with right using {cmd:mat_capp}{p_end}
{p2col :{bf:\}}Row concantenate left with right (i.e., stack){p_end}
{p2col :{bf:\\}}Row concantenate left with right using {cmd:mat_rapp}{p_end}
{p2line}
{p2colset 7 21 22 0}
{pstd}
{p_end}

{dlgtab:Unary operations}

{p 6 10 2}
{cmd:matmath } {it:Mresult} = {it:operator}({it:Mleft})

{p2colset 10 22 22 12}{...}
{p2col :Operator}What it does{p_end}
{p2line}
{p2col :{bf:sqrt}}Square root{p_end}
{p2col :{bf:sq}}Square.{p_end}
{p2col :{bf:log}}Natural log.{p_end}
{p2col :{bf:exp}}exp().{p_end}
{p2col :{bf:inv}}Inverse.{p_end}
{p2col :{bf:log10}}Log base 10.{p_end}
{p2col :{bf:odds}}Odds transformation (x/(1-x)).{p_end}
{p2col :{bf:logit}}Logit transformation log(x/(1-x)).{p_end}
{p2line}
{p2colset 7 21 22 0}
{pstd}
{p_end}

{dlgtab:Row and columns selection and reordering}

{p 6 10 2}
{cmd:matmath } {it:Mresult} = [{it:task}]({it:Mleft}), [ {opt rows(numlist)} {opt col:umns(numlist)} ]

{p2colset 10 22 22 12}{...}
{p2col :Operator}What it does{p_end}
{p2line}
{p2col :{bf:keep}}Keep rows and columns in rows() and columns().{p_end}
{p2col :{bf:drop}}Drop rows and columns in rows() and columns(). The original ordering is maintained.{p_end}

{p2line}
{p2colset 7 21 22 0}
{pstd}
{p_end}

{synopt:{opt rows(numlist)}}
Select rows from {it:Mleft}.
With {cmd:keep}, this order is retained in {it:Mresult}. The same rows can be repeated.
{p_end}

{synopt:{opt col:umns(numlist)}}
Select columns from {it:Mleft}.
With {cmd:keep}, this order is retained in {it:Mresult}. Columns can be repeated.
{p_end}

{title:Author}

{p 2 5 10}
Scott Long

{p 2 8 0}
{browse "http://www.indiana.edu/~jslsoc/spost.htm":The SPost website.}
{browse "http://www.indiana.edu/~jslsoc/web_workflow/wf_home.htm":The Workflow website.}
{p_end}
