{smcl}
{* 2014-08-03}{...}
{title:Title}
{p2colset 5 16 23 2}{...}

{p2col:{cmd:matrow} {hline 2}}Matrix operations on rows made simple | 2014-08-03{p_end}
{p2colreset}{...}

{title:General syntax}

{p 2 18 2}
{ul:Binary operations on rows}

{p 6 6 2}
{cmd:matrow } {it:Msource} {it:changedrow} = {it:leftrow} {it:operator} {it:rightrow}

{p 2 18 2}
{ul:Unary operations on rows}

{p 6 6 2}
{cmd:matrow } {it:Msource} {it:changedrow} = {it:operator}({it:row})

{p 2 18 2}
{ul:Statistics operations on matrix}

{p 6 6 2}
{cmd:matrow } {it:Msource} {it:changedrow} = {it:operator} [, {opt r:ows(numlist)}]

{p 2 18 2}
{ul:Utility operations on matrix}

{p 6 6 2}
{cmd:matrow } {it:Msource} {it:changedrow} = {it:operator} [, {opt r:ows(numlist)}]

{p 2 18 2}
{ul:Matrix}

{p 6 6 2}
{it:Msource} is the matrix to be modified. Note that the original content might be overwritten.

{p 2 18 2}
{ul:Specifying rows}

{p 6 6 2}
The rows in {it:Msource} that is changed and the rows with information used to create the new information are specified as follows:

{p2colset 10 15 15 15}{...}
{p2line}
{p2col :#}Change that row; add rows if # exceeds dimension of matrix{p_end}
{p2col :n}Add one row to bottom of matrix{p_end}
{p2col :l}Last rows (lower case L){p_end}
{p2col :p}Prior row created by adding row at top of matrix{p_end}
{p2line}
{p2colset 7 21 22 0}
{pstd}
{p_end}
{p 6 9 2}
{it:changedrow} the row to be changed in {it:Msource}. If the row does not exist (e.g., row 5 in a 3x3 matrix) additional rows filled with missing values .z are added.

{p 6 9 2}
{it:leftrow} in binary operations, this is the row to the left of the operator.

{p 6 9 2}
{it:rightrow} in binary operations, this is the row to the right of the operator.

{p 6 6 2}
{it:row} in unary operations, this row is modified to create the {it:changedrow}.

{p 2 18 2}
{ul:Options for all types of operations}

{p 6 6 2}
{opt list} list matrix after changes.

{p 6 6 2}
{opt name(string)} row {it:changedrow#} is given this row name in the matrix.

{marker overview}
{title:Overview}

{pstd}
{cmd:matrow} makes changes to the matrix based on row operations
such as adding two rows, summing over rows, taking the square root of a row.
{p_end}

{title:Expanded syntax}

{dlgtab:Binary operations}

{p 6 10 2}
{cmd:matrow } {it:Msource} {it:changedrow} = {it:leftrow} {it:operator} {it:rightrow}

{p2colset 10 22 22 12}{...}
{p2col :Operator}What it does{p_end}
{p2line}
{p2col :{bf:+}}Addition of left and right{p_end}
{p2col :{bf:-}}Subtraction left from right{p_end}
{p2col :{bf:*}}Multiplication left times right{p_end}
{p2col :{bf:/}}Division left by right{p_end}
{p2col :{bf:^}}Exponentiation of left to right power{p_end}
{p2col :{bf:%of}}Left as percent of right{p_end}
{p2col :{bf:%dif}}Change from left to right as percent of left{p_end}
{p2line}
{p2colset 7 21 22 0}
{pstd}
{p_end}

{dlgtab:Unary operations}

{p 6 6 2}
{cmd:matrow } {it:Msource} {it:changedrow} = {it:operator}({it:row})

{p2colset 10 22 22 12}{...}
{p2col :Operator}What it does{p_end}
{p2line}
{p2col :{bf:sqrt}}Square root{p_end}
{p2col :{bf:sq}}Square.{p_end}
{p2col :{bf:log}}Natural log.{p_end}
{p2col :{bf:log10}}Log base 10.{p_end}
{p2col :{bf:exp}}exp().{p_end}
{p2col :{bf:inv}}Inverse.{p_end}
{p2line}
{p2colset 7 21 22 0}
{pstd}
{p_end}

{dlgtab:Statistics}

{p 6 6 2}
{cmd:matrow } {it:Msource} {it:changedrow} = {it:operator} [, {opt r:ows(numlist)}]

{p 6 6 2}
For each column, statistics are computed based on information in the rows. The {opt r:ows(numlist)} option lets you select which rows to use in computing statistics.

{p2colset 10 22 22 12}{...}
{p2col :Operator}What it does{p_end}
{p2line}
{p2col :{bf:min}}minimum over selected rows.{p_end}
{p2col :{bf:max}}maximum over selected rows.{p_end}
{p2col :{bf:mean}}mean of selected rows.{p_end}
{p2col :{bf:sd}}standard deviation of selected rows.{p_end}
{p2col :{bf:var}}variance of selected rows.{p_end}
{p2col :{bf:range}}range over selected rows.{p_end}
{p2line}
{p2colset 7 21 22 0}
{pstd}
{p_end}

{synopt:{opt r:ows(numlist)}}
Select rows from {it:Msource} that are used when computing statistics.
{p_end}

{dlgtab:Utility}

{p 6 6 2}
{cmd:matrow } {it:Msource} {it:changedrow} = {it:operator}

{p2colset 10 22 22 12}{...}
{p2col :Operator}What it does{p_end}
{p2line}
{p2col :{bf:number}}Create a row indicting the column number.{p_end}
{p2line}
{p2colset 7 21 22 0}
{pstd}
{p_end}

{synopt:{opt r:ows(numlist)}}
Select rows from {it:Msource} that are used when computing statistics.
{p_end}

{title:Author}

{p 2 5 10}
Scott Long

{p 2 8 0}
{browse "http://www.indiana.edu/~jslsoc/spost.htm":The SPost website.}
{browse "http://www.indiana.edu/~jslsoc/web_workflow/wf_home.htm":The Workflow website.}
{p_end}
