program drop _all
capture log close
log using it, replace text
version 13
clear all
set linesize 80
macro drop _all
set scheme s2color

//  compare logit and probit

spex logit
matrix logit = r(table)'
matrix coleq logit = "logit"
matmath logit = drop(logit), rows(3 6 8) cols(2 5 6 7 8 9) list

spex probit
matrix probit = r(table)'
matrix coleq probit = "probit"
matmath probit = drop(probit), rows(3 6 8) cols(2 5 6 7 8 9) list

matmath ratio = logit / probit, list
matrix coleq ratio = "ratio"

matrix compare = logit, probit, ratio
matlist compare, format(%8.3f)

//  stats: accumulate all stats using row

matrix a = (11, 12, 13, 14) \ (21, 22, 23, 24) \ (31, 32, 33, 34)
mat rowna a = row1 row2 row3
mat colna a = col1 col2 col3 col4

matrow a n = sum, list name(sum) row(1 2 3)
matrow a n = min, list name(min) row(1 2 3)
matrow a n = max, list name(max) row(1 2 3)
matrow a n = mean, list name(mean) row(1 2 3) list
matrow a n = sd, list name(sd) row(1 2 3) list
matrow a n = var, list name(var) row(1 2 3) list

exit
//  matwork

* 33
matrix a = (11, 12, 13) \ (21, 22, 23) \ (31, 32, 33)
mat rowna a = ra1 ra2 ra3
mat colna a = ca1 ca2 ca3

* 4x3
matrix b = (11, 12, 13) \ (21, 22, 23) \ (31, 32, 33) \ (41, 42, 43)
mat rowna b = r:b1 r:b2 r:b3 r:b4
mat colna b = c:b1 c:b2 c:b3

matrix c1 = J(5,5,1)
matrix c2 = J(5,5,2)
matrix c3 = J(5,5,3)

matrix d1 = J(3,3,11)
matrix d2 = J(3,3,22)
matrix d3 = J(3,3,33)

//  +

matmath tmp = a + 1, list
matmath tmp = a + b, list
matmath tmp = a + a, list

//  -

matmath tmp = c3 - c2, list

//  /

matmath tmp = c2 / 2, list
matmath tmp = c1 / c3, list

//  *

matmath tmp = c2 * 2, list
matmath tmp = c1 * c3, list

//  ^

matmath tmp = c2 ^ 2, list
matmath tmp = c1 ^ c3, list

//  %of

matmath tmp = c1 %of c2, list
matmath tmp = c2 %of c3, list

//  %dif"

matmath tmp = c1 %dif c2, list
matmath tmp = c2 %dif c3, list

//  ,

matmath tmp = c2 , c3, list

//  ,,

matmath tmp = c2 ,, d3, list

//  \

matmath tmp = c2 \ c3, list

//  \\

matmath tmp = a \\ c3, list

//  sqrt sq log log10 exp  inv

matmath c = sqrt(a), list
matmath c = sq(a), list
matmath c = log(a), list
matmath c = log10(a), list
matmath c = exp(a), list
matmath c = inv(a), list


//  keep and drop
matmath c = keep(a), r(1 2 2 1) col(1) list
matmath c = drop(a), row(1/2) cols(1 2) list

log close
exit

matmath c = keep(b), r(1 2) col(1) list

exit

mat b = J(3,3,2) // 3x3
mat rowna a = ra1 ra2 ra3
mat colna a = ca1 ca2 ca3


exit

* combine
matmath c = a , b, list
matmath c = a \ b, list
matmath c = a ,, b, list
matmath c = a \\ b, list

exit





mat a = J(3,3,1) // 3x3
mat rowna a = ra1 ra2 ra3
mat colna a = ca1 ca2 ca3
mat b = J(3,4,2) // 3x4
mat rowna b = rb1 rb2 rb3
mat colna b = cb1 cb2 cb3 cb4


exit

*

matmath c = a , b
matmath c = a \ b
matmath c = a capp b


log close
exit  /*
program drop _all

set traced 8
set tracehilite "margins" , word
set trace off
capture log close _all
log using matwork, replace text

version 12.1
clear all
macro drop _all
set linesize 80
set scheme sj

program drop _all

//  or and dc plot
sysuse nomocc4, clear
mlogit occ i.white ed exper, baseoutcome(5) nolog
    _mchange_end[15,5]
    _mchange_start[15,5]
    _mchange_pvalue[15,5]
    _mchange_se[15,5]
    _mchange_z[15,5]
    _mchange_ll[15,5]
    _mchange_ul[15,5]
    _mchange_dc[15,5]
*/
/*
mchange, atmeans
mat dir
matwork _mchange_start minus _mchange_end equals diff
*/

matrix dog = _mchange_dc
rowwork 2 - 2 = 3 in dog
rowwork 2 - 2 = 20 in dog

exit
set trace off
mat indx = (1, 3, 5)'
matwork _mchange_start index indx equals sel

log close
exit
